#ifndef _M8HELP_H_
#define _M8HELP_H_


#define nop() asm("nop")

#define TIMER0_PRESCALER_OFF  ((0<<CS02) | (0<<CS01) | (0<<CS00))
#define TIMER0_PRESCALER_1    ((0<<CS02) | (0<<CS01) | (1<<CS00))
#define TIMER0_PRESCALER_8    ((0<<CS02) | (1<<CS01) | (0<<CS00))
#define TIMER0_PRESCALER_64   ((0<<CS02) | (1<<CS01) | (1<<CS00))
#define TIMER0_PRESCALER_256  ((1<<CS02) | (0<<CS01) | (0<<CS00))
#define TIMER0_PRESCALER_1024 ((1<<CS02) | (0<<CS01) | (1<<CS00))
#define TIMER0_PRESCALER_EF   ((1<<CS02) | (1<<CS01) | (0<<CS00))
#define TIMER0_PRESCALER_ER   ((1<<CS02) | (1<<CS01) | (1<<CS00))

#define TIMER0_IRQ_ENABLE()  TIMSK |= (1<<TOIE0)
#define TIMER0_IRQ_DISABLE() TIMSK &= ~(1<<TOIE0)

#define TIMER0_IRQ_CLEAR()   TIFR |= (1<<TOV0)


#define INT0_IRQ_ENABLE()  GICR |= (1<<INT0)
#define INT0_IRQ_DISABLE() GICR &= ~(1<<INT0)

#define INT0_IRQ_CLEAR()   GIFR |= (1<<INTF0)

#define INT0_ON_LOW()      MCUCR = (MCUCR & ~((1<<ISC01) | (1<<ISC00))) | ((0<<ISC01) | (0<<ISC00))
#define INT0_ON_CHANGE()   MCUCR = (MCUCR & ~((1<<ISC01) | (1<<ISC00))) | ((0<<ISC01) | (1<<ISC00))
#define INT0_ON_FALL()     MCUCR = (MCUCR & ~((1<<ISC01) | (1<<ISC00))) | ((1<<ISC01) | (0<<ISC00))
#define INT0_ON_RISE()     MCUCR = (MCUCR & ~((1<<ISC01) | (1<<ISC00))) | ((1<<ISC01) | (1<<ISC00))

#endif
