#include "uart.h"
#include <stdlib.h>

#define BUFFLEN 5

volatile uint8_t inbuff[BUFFLEN] = {0};
volatile uint8_t setdata = 0;


void uart_init() {
  UBRRH = (uint8_t)(UART_UBRR_CALC(UART_BAUD_RATE,F_CPU)>>8);
  UBRRL = (uint8_t)UART_UBRR_CALC(UART_BAUD_RATE,F_CPU);

  UCSRB = (1<<RXCIE) | (1<<RXEN) | (1<<TXEN);
  //UCSRC = (1<<URSEL) | (3<<UCSZ0);
  UCSRC = (1<<URSEL) | //dieses Register wird verwendet
     (0<<UMSEL) | //Asynchrone bertragung
     (0<<UPM1) | (0<<UPM0) | //keine Paritt
     (0<<USBS) | //1 Stoppbits
     (0<<UCSZ2) | (1<<UCSZ1) | (1<<UCSZ0) | //8 Bits
     (0<<UCPOL); //steigende Flanke
}

void uart_putc(uint8_t outchar) {
  while(!(UCSRA & (1<<UDRE)));
    UDR = outchar;
}

void uart_puts(char *s) {
	while(*s) {
		uart_putc(*s++);
	}
}

void uart_puthex(uint8_t hex) {
	uint8_t tmp;
	//uart_puts("0x");
	for(uint8_t i = 0; i < 2; i++) {
		tmp = hex & 0xF0;
		tmp >>= 4;
		tmp += (tmp < 10) ? 48 : 55;
		hex <<= 4;
		uart_putc(tmp);
	}
}

void uart_putnum(int16_t num) {
	char buff[7];
	itoa(num, buff, 10);
	uart_puts(buff);
}
